import json
import requests
from http.server import BaseHTTPRequestHandler, HTTPServer
import time
from datetime import datetime
import openai
import random
import settings

openai.organization = "org-hNNV1yHjZp7T3pn5pdZWaKLm"
#print(openai.Model.list())



URL="https://api.openai.com/v1/completions"

DATA = {"model": "text-davinci-003",
    "prompt": settings.PROMPTS[0],
    "temperature":1,
    "max_tokens": 200
}   

request_headers={"Authorization": "Bearer "+settings.APIKEY,"Content-Type": "application/json"}

   
class IDGAFServer(BaseHTTPRequestHandler):

    def do_PATCH(self):
#        print("Request: "+self.request+ " "+webServer.get_request())
        request_body=self.rfile.read(int(self.headers.get('Content-Length')))
        command=json.loads(request_body)
        print(command)
        if command['message']['command'] == 'aidgaf':
            [responseCode,response_body]=parse_idgaf_request(command)
            self.handle_response(responseCode,response_body)
            print("sending:"+response_body)
       


    def handle_response(self,code,body):
        self.send_response(code)
        self.send_header("Content-type", "text/html")
        self.end_headers()
        self.wfile.write(bytes(body,"UTF-8"))


def get_response_base_object(text):
    resultObject={}
    resultObject["message"]={}
    resultObject["service"]="AIDGAF Server"
    resultObject["message"]["data"]={}
    resultObject["message"]["data"]["resultObject"]=text
    resultObject["timestamp"]=datetime.utcnow().timestamp()
    return resultObject
        

def parse_idgaf_request(command):
    the_data=get_prompt(command)
    gpt_response=requests.post(URL, json=the_data, headers=request_headers)
    print(gpt_response)
    response_text=gpt_response.json()['choices'][0]['text'].strip()
    obj=get_response_base_object(response_text)
    json_result=json.dumps(obj)
    return [gpt_response.status_code,json_result]

def get_prompt(command):
    my_prompt=random.choice(settings.PROMPTS)
    my_prompt=my_prompt.replace("USERNAME",command['message']['data']['username'])

    print("Prompt selected: "+my_prompt)
    the_data=DATA
    the_data["prompt"]=my_prompt
    return the_data


value='{"service": "papa", "message": {"command": "aidgaf", "data": {"username": "AdamOutler"}, "timestamp": 1675373229}, "hash": "de08e85b8afc3b7d257fa559fd1dd295838ea1387f1e0fa75ceb11d9da81e59fadfc878d028281dfb739002bae818b89a8363e49d68e923874c969716a90f8e3"}'
if __name__ == "__main__":
    print(parse_idgaf_request(command=json.loads(value)))


#curl https://api.openai.com/v1/completions \
#    -H "Content-Type: application/json" \
#    -H "Authorization: Bearer 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" \
#    -d '{"model": "text-curie-001", 
#        "prompt": "Say \"Adam does not give a fuck\" in a thoughtful and clever prose consisting of one to five paragraphs.",
#        "temperature":1, "max_tokens": 500}'
#        |jq -r .choices[0].text
# curl -X PATCH 127.0.0.1:8087 -d '{"message":{"command":"aidgaf","data":{"username":"AdamOutler"}}}'
#2,500,000 tokens = $5